function ret = test_balistika ()
x0 = 50*[-1 1];  % [m]
v_ = 100;        % [m s^-1]
vo = 10;         % [m s^-1]
g  = 9.81;       % [m s^-2]
Cx = 0.5;        % []   ... koule
rh = 1.29;       % [kg m^-3]
S  = pi*0.1^2;   % [m^2]
Dt = 0.1;        % [s]
t  = 0:Dt:10;    % [s]
nt = size(t,2);
CxrhS2 = Cx*S*rh/2;

h0 = 10;
al = ((20:10:80)*pi/180)';   nal = size(al,1);

Xa = zeros( 4*nal, nt);   Xa(1:nal,1) =  x0(1);   Xa((2*nal+1):3*nal,1) =  v_*cos(al);   Xa((3*nal+1):4*nal,1) =  v_*sin(al);
Xb = zeros( 4*nal, nt);   Xb(1:nal,1) =  x0(2);   Xb((2*nal+1):3*nal,1) = -v_*cos(al);   Xb((3*nal+1):4*nal,1) =  v_*sin(al);

% Resime soustavu pro Y(t) = [x;v](t)
% X'(t) = F(t,X(t)) = [v(t); a(t)] kde a(t) = [0 -g] + 0.5*Cx*rh*S*(v(t)-[vo 0])
function ret__ = F(t,Y)
  nY__  = size(Y,1)/4;
  v__   = Y(end/2+1:end,1)-vo*[ones(nY__,1);zeros(nY__,1)];
  nv__  = sqrt(v__(1:nY__,1).^2+v__(1+nY__:2*nY__,1).^2);   nv__ = [ nv__; nv__];
  F__   = -g*[zeros(nY__,1);ones(nY__,1)] ;
  ret__ = [Y(end/2+1:end,1); -g*[zeros(nY__,1);ones(nY__,1)] - CxrhS2*(nv__.*v__)];
endfunction

% RK2 solver
for i =1:nt
  K1 = F(t     ,Xa(:,i)         );
  K2 = F(t+Dt/2,Xa(:,i)+(Dt/2)*K1);   co = Xa(nal+1:2*nal,1) >= 0;
  Xa(:,i+1)   = Xa(:,i) + Dt * K2; 
  K1 = F(t     ,Xb(:,i)         );
  K2 = F(t+Dt/2,Xb(:,i)+(Dt/2)*K1);   co = Xb(nal+1:2*nal,1) >= 0;
  Xb(:,i+1)   = Xb(:,i) + Dt * K2; 
endfor
figure(1); hold on;

line([0 0],[0,h0],'linestyle','-','color','k','linewidth',3); 
plot( x0(1),0,'xr');
plot( x0(2),0,'xb');
for i =1:nal
  line( Xa(i,:), Xa(i+nal,:), 'linestyle', '-', 'color', 'r');
  line( Xb(i,:), Xb(i+nal,:), 'linestyle', '-', 'color', 'b');  
endfor

endfunction
